/** 
 * Ordinamento di interi e stringhe 
 * Test su: 
 * GenericSort.heapSort (T [] x);
 * Heapsort.heapSort (T [] x):
 * */

import java.util.*;

public class HeapSortTest
{
    public static void main(String[] args)
    {
        new HeapSortTest().runIntegers();
        System.out.println ();
        new HeapSortTest().runStrings();
    } // method main

    public void runIntegers()
    {
        int L = 15, MAXINT = 500;
        Integer[ ] numbers = new Integer[L]; 
 
        Random r = new Random ();
        for (int i = 0; i < L; i++) numbers[i]=r.nextInt(MAXINT);
  
        GenericSort.heapSort (numbers);
        //Heapsort.heapSort (numbers);
        for (Integer s : numbers)
            System.out.print (s + "  ");
   } // method runIntegers
    
    
    
    public void runStrings()
    {
	String[ ] strings = {"Marco", "Giovanna", "Luca", "Alex", "Rita", "Federica"},
			  strings2 = {"Alessio", "Beatrice", "Carlo", "Mattia"}	; 
  
        GenericSort.heapSort (strings);
        Heapsort.heapSort (strings2);
		System.out.println("\nOrdine lessicografico crescente:");
        for (String s : strings)
            System.out.print (s + "  ");
        System.out.println();
        for (String s : strings2)
            System.out.print (s + "  ");
		
		System.out.println("\n\nOrdine lessicografico decrescente:");
		GenericSort.heapSort (strings, new String_Decreasing());
		Heapsort.ListHeapSort (strings2, new String_Decreasing());
		for (String s : strings)
            System.out.print (s + "  ");
		System.out.println();
		for (String s : strings2)
            System.out.print (s + "  ");

		System.out.println("\n\nOrdine crescente di lunghezza:");		
		GenericSort.heapSort (strings, new String_byLength());
		Heapsort.ListHeapSort (strings2, new String_byLength());
		for (String s : strings)
            System.out.print (s + "  ");
		System.out.println();
		for (String s : strings2)
            System.out.print (s + "  ");

	
   } // method runStrings



class String_byLength implements Comparator<String> {

 /**
   * Compares the String object s1 with the String object s2.
   * The comparison is by length.
   */
  public int compare (String s1, String s2) {
	int diff = s1.length() - s2.length();  
    if (diff != 0) return diff;
    else return s1.compareTo(s2);
  } // method compare

}  //class String_byLength



class String_Decreasing implements Comparator<String> {

 /**
   * Compares the String object s1 with the String object s2.
   * The comparison is in decreasing order
   */
  public int compare (String s1, String s2) {
    return s2.compareTo(s1);
  } // method compare

}  //class String_byLength
   
   




} // class HeapSortExample


